# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Office do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :IDXOfficeParticipationYN,
    :MainOfficeKeyNumeric,
    :OfficeAORkeyNumeric,
    :OfficeBrokerKeyNumeric,
    :OfficeKeyNumeric,
    :OfficeManagerKeyNumeric,
    :FranchiseAffiliation,
    :MainOfficeKey,
    :MainOfficeMlsId,
    :OfficeAORMlsId,
    :OfficeAORkey,
    :OfficeAddress1,
    :OfficeAddress2,
    :OfficeAssociationComments,
    :OfficeBrokerKey,
    :OfficeBrokerMlsId,
    :OfficeCity,
    :OfficeCorporateLicense,
    :OfficeEmail,
    :OfficeFax,
    :OfficeKey,
    :OfficeManagerKey,
    :OfficeManagerMlsId,
    :OfficeMlsId,
    :OfficeName,
    :OfficeNationalAssociationId,
    :OfficePhone,
    :OfficePhoneExt,
    :OfficePostalCode,
    :OfficePostalCodePlus4,
    :OriginatingSystemID,
    :OriginatingSystemName,
    :OriginatingSystemOfficeKey,
    :SourceSystemID,
    :SourceSystemName,
    :SourceSystemOfficeKey,
    :SyndicateTo,
    :OfficeAOR,
    :OfficeBranchType,
    :OfficeCountyOrParish,
    :OfficeStateOrProvince,
    :OfficeStatus,
    :OfficeType,
    :SocialMediaType,
    :SyndicateAgentOption,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :OfficeBroker,
    :OfficeManager,
    :MainOffice,
    :OriginatingSystem,
    :SourceSystem,
    :Members,
    :Offices,
    :BuyerOfficeProperties,
    :CoBuyerOfficeProperties,
    :CoListOfficeProperties,
    :ListOfficeProperties
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :IDXOfficeParticipationYN => boolean() | nil,
    :MainOfficeKeyNumeric => float() | nil,
    :OfficeAORkeyNumeric => float() | nil,
    :OfficeBrokerKeyNumeric => float() | nil,
    :OfficeKeyNumeric => float() | nil,
    :OfficeManagerKeyNumeric => float() | nil,
    :FranchiseAffiliation => String.t | nil,
    :MainOfficeKey => String.t | nil,
    :MainOfficeMlsId => String.t | nil,
    :OfficeAORMlsId => String.t | nil,
    :OfficeAORkey => String.t | nil,
    :OfficeAddress1 => String.t | nil,
    :OfficeAddress2 => String.t | nil,
    :OfficeAssociationComments => String.t | nil,
    :OfficeBrokerKey => String.t | nil,
    :OfficeBrokerMlsId => String.t | nil,
    :OfficeCity => String.t | nil,
    :OfficeCorporateLicense => String.t | nil,
    :OfficeEmail => String.t | nil,
    :OfficeFax => String.t | nil,
    :OfficeKey => String.t | nil,
    :OfficeManagerKey => String.t | nil,
    :OfficeManagerMlsId => String.t | nil,
    :OfficeMlsId => String.t | nil,
    :OfficeName => String.t | nil,
    :OfficeNationalAssociationId => String.t | nil,
    :OfficePhone => String.t | nil,
    :OfficePhoneExt => String.t | nil,
    :OfficePostalCode => String.t | nil,
    :OfficePostalCodePlus4 => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemName => String.t | nil,
    :OriginatingSystemOfficeKey => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemName => String.t | nil,
    :SourceSystemOfficeKey => String.t | nil,
    :SyndicateTo => [String.t] | nil,
    :OfficeAOR => String.t | nil,
    :OfficeBranchType => String.t | nil,
    :OfficeCountyOrParish => String.t | nil,
    :OfficeStateOrProvince => String.t | nil,
    :OfficeStatus => String.t | nil,
    :OfficeType => String.t | nil,
    :SocialMediaType => String.t | nil,
    :SyndicateAgentOption => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :OfficeBroker => FoyerAPI.Model.Member.t | nil,
    :OfficeManager => FoyerAPI.Model.Member.t | nil,
    :MainOffice => FoyerAPI.Model.Office.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :Members => [FoyerAPI.Model.Member.t] | nil,
    :Offices => [FoyerAPI.Model.Office.t] | nil,
    :BuyerOfficeProperties => [FoyerAPI.Model.Property.t] | nil,
    :CoBuyerOfficeProperties => [FoyerAPI.Model.Property.t] | nil,
    :CoListOfficeProperties => [FoyerAPI.Model.Property.t] | nil,
    :ListOfficeProperties => [FoyerAPI.Model.Property.t] | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Office do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:OfficeBroker, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OfficeManager, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:MainOffice, :struct, FoyerAPI.Model.Office, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:Members, :list, FoyerAPI.Model.Member, options)
    |> deserialize(:Offices, :list, FoyerAPI.Model.Office, options)
    |> deserialize(:BuyerOfficeProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:CoBuyerOfficeProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:CoListOfficeProperties, :list, FoyerAPI.Model.Property, options)
    |> deserialize(:ListOfficeProperties, :list, FoyerAPI.Model.Property, options)
  end
end

